package com.muyu.util;

import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;

import javax.tools.JavaCompiler;
import javax.tools.JavaFileObject;
import javax.tools.StandardJavaFileManager;
import javax.tools.ToolProvider;
import java.io.File;
import java.util.Arrays;
import java.util.Collections;
import java.util.List;

public class SourceCodeCompiler {

    private static final Logger log = LogManager.getLogger(SourceCodeCompiler.class.getName());

    /**
     * 获取系统java编译器
     */
    private static JavaCompiler compiler = ToolProvider.getSystemJavaCompiler();
    /**
     * 获取java文件管理器
     */
    private static StandardJavaFileManager fileManager = compiler.getStandardFileManager(null, null, null);


    /**
     * 输入编译的文件夹路径
     * @param path 文件夹路径
     */
    public static void javaCompilerPath(String path){
        try {
            List<File> files = JavaCodeScan.getJavaFiles(path);
            System.out.println(files);
            File[] array = files.toArray(new File[files.size()]);
            javaCompiler(array);
        }catch (Exception e){
            log.error(e);
        }
    }


    public static void javaCompilerFile(String... filePath){
        int filePathLength =  filePath.length;
        File[] files = new File[filePathLength];

        for (int i = 0; i < filePathLength; i++) {
            files[i] = new File(filePath[i]);
        }
        javaCompiler(files);
    }


    /**
     *可以同时编译多个java源代码
     * @param file
     */
    public static void javaCompiler(File...file){
        try {
            //通过源文件获取到想要编译的java类源代码迭代器，包括所有的内部类，其中每一个类都是一个JavaFileObjects，也被称为一个汇编单元
            Iterable<? extends JavaFileObject> javaFileObjects = fileManager.getJavaFileObjects(file);
            //生成编译任务
            JavaCompiler.CompilationTask task = compiler.getTask(null, fileManager, null, Arrays.asList("-d","home/","cp","/home/app.jar"), null, javaFileObjects);
            //执行编译任务
            task.call();
        }catch (Exception e){
            log.error(e);
        }
    }

    //        try {
//            // 初始化 fileManager（此处省略，假设您已有此步骤）
//
//            // 创建一个包含所有依赖 JAR 文件的类路径列表
//            List<String> classpath = Arrays.asList(
//                    "/home/app.jar"
//            );
//
//            // 通过源文件获取到想要编译的 JavaFileObjects
//            Iterable<? extends JavaFileObject> javaFileObjects = fileManager.getJavaFileObjectsFromFiles(Arrays.asList(file));
//
//            // 生成编译任务，包含类路径
//            JavaCompiler.CompilationTask task = compiler.getTask(null, fileManager, null,
//                    Collections.singletonList("-d"), null, classpath, javaFileObjects);
//
//            // 执行编译任务
//            boolean success = task.call();
//            if (!success) {
//                throw new RuntimeException("Compilation failed");
//            }
//        } catch (Exception e) {
//            // 适当的错误处理
//            e.printStackTrace(); // 或使用日志记录
//        }

}
